// MySynth.cpp
// MySynthNX̒`BVSTivOCCNXƂłׂNXB
// ÃNX̓bp[̂悤Ȃ̂Ȃ̂ŁAʏ́AɎꕔ̎ʏ
// CKv͂ȂB


// VSTSDKAWindowsAAKvȃwb_
#pragma warning(disable:4996)
#include <pluginterfaces/vst2.x/aeffect.h>
#include <public.sdk/source/vst2.x/audioeffectx.h>
#include <public.sdk/source/vst2.x/aeffeditor.h>
#include <windows.h>
#include <math.h>
#include <list>
#include "common.h"
#include "debug.h"
#include "synthBase.h"
#include "MySynthMain.h"
#include "MySynth.h"

// VSTSDK(ʂ̓RpCPʂ𕪂邪Aʓ|Ȃ̂ł̂悤ɂ)
#include <public.sdk\source\vst2.x\audioeffect.cpp>
#include <public.sdk\source\vst2.x\audioeffectx.cpp>
#include <public.sdk\source\vst2.x\vstplugmain.cpp>

// VSTIuWFNg̐֐
AudioEffect* createEffectInstance(audioMasterCallback audioMaster){
	// MySynth̐
	return new CMySynth(audioMaster);
}


// CMySynthNXRXgN^
CMySynth::CMySynth(audioMasterCallback audioMaster) : AudioEffectX(audioMaster, PROGRAM_NUM, SOUND_PARAM_NUM){
	// fobOEBhẼI[v()
	startDbgWin((HINSTANCE)hInstance);	// hInstancéAvstplugmain.cppŃO[oϐƂĒ`ĂB

	// Cxg֘Aϐ̏
	m_currentEventNo=m_eventNum=m_eventMaxNum=m_currentSample=0;
	m_events=NULL;

	// ̃vOC̊e푮ݒ肷
	programsAreChunks();	// Ff[^͓Ǝ`Nŕۑ
	setNumInputs(0);		// ͂Ȃ
	setNumOutputs(2);		// XeIo
	isSynth();				// VZł
	setUniqueID('VxS2');	// ̃vOCƎ̃j[NIDBvOCJꍇSteinberg擾邱ƁB

	// VZ{̂̐
	m_pSynth = new CMySynthMain();

	// GUI̐
//	setEditor(new hoge(this));

	// JgvOOԂɐݒ
	curProgram=0;
	setProgram(0);
	suspend();
}


// CMySynthNXfXgN^
CMySynth::~CMySynth(){
	// Cxgobt@J
	if(m_pSynth != NULL) delete m_pSynth;
	if(m_events) delete[] m_events;

	endDbgWin();
}

// ̃vOC̖OԂ
bool CMySynth::getEffectName (char* name){
	vst_strncpy (name, "MySynth", kVstMaxEffectNameLen);
	return true;
}

// x_[Ԃ
bool CMySynth::getVendorString (char* text){
	vst_strncpy (text, "hoge", kVstMaxVendorStrLen);
	return true;
}

// ̃vOCɊւeLXgԂ
bool CMySynth::getProductString (char* text){
	vst_strncpy (text, "Vst Synth", kVstMaxProductStrLen);
	return true;
}

// x_[ŗLo[WԂ
VstInt32 CMySynth::getVendorVersion (){ 
	return 1000; 
}

// ̃vOCŃT|[g@\Ԃ
VstInt32 CMySynth::canDo(char* text){
	if(!strcmp(text,"receiveVstEvents"))	return 1;
	if(!strcmp(text,"receiveVstMidiEvent"))	return 1;
	return -1;
}


// MIDICxgM
VstInt32 CMySynth::processEvents(VstEvents* ev){
	m_currentEventNo=0;
	m_eventNum=0;
	m_currentSample=0;

	if(ev->numEvents>0){
		if(m_eventMaxNum < ev->numEvents){
			// ̃obt@TCYŏ̂ŁATCYg
			if(m_events) delete[] m_events;
			m_eventMaxNum = ev->numEvents;
			m_events = new VstEvent[m_eventMaxNum];
		}
		// "MIDIVXebZ[W"ȊOMIDICxgȂobt@փRs[
		for(int i=0;i<ev->numEvents;i++){
			VstMidiEvent* pE = (VstMidiEvent*)ev->events[i];
			if((ev->events[i]->type==kVstMidiType) && ((pE->midiData[0] & 0xf0) != 0xf0)){
				// VXebZ[WȊOȂ̂ŁAobt@֒ǉ
				m_events[m_eventNum] = *(ev->events[i]);
				m_eventNum++;
			}
		}
	}
	return 1;
}


// M֐
void CMySynth::processReplacing(float** inputs, float** outputs, VstInt32 sampleFrames){
	int nRestSample=sampleFrames;
	VstMidiEvent *pE;
	float* out1 = outputs[0];
	float* out2 = outputs[1];
	int nProcessSample;

	// e|ݒ
	VstTimeInfo *vti = getTimeInfo(kVstTempoValid);
	if(vti) m_pSynth->setBaseTempo((float)vti->tempo);

	while(nRestSample>0){
		// ̃Cxg܂ł̏łTv߂
		if(m_currentEventNo<m_eventNum){	// Cxg
			pE = (VstMidiEvent*)&m_events[m_currentEventNo];
			nProcessSample=MAX(0,MIN(nRestSample,pE->deltaFrames-m_currentSample));
		}else{								// CxgȂ
			pE=NULL;
			nProcessSample=nRestSample;
		}

		// M
		// SSEgpO16oCgEɑăobt@m
		CACHE_ALIGN16 SIG_LR dataLR[MAX_SIGBUF];
		int nRestSample2=nProcessSample;
		while(nRestSample2>0){
			int size=MIN(sizeof(dataLR)/sizeof(SIG_LR),nRestSample2);
			BOOL processed=FALSE;
			m_pSynth->processSignalLR(size,dataLR,&processed);
			if(processed)	for(int i=0;i<size;i++){*out1++ = dataLR[i].l;	*out2++ = dataLR[i].r;}
			else			for(int i=0;i<size;i++){*out1++ = 0;			*out2++ = 0;}

			nRestSample2 -= size;
		}
		nRestSample -= nProcessSample;
		m_currentSample += nProcessSample;

		// Cxg
		if(pE){
			m_pSynth->processMIDIShortData(pE->midiData[0],pE->midiData[1],pE->midiData[2]);
			m_currentEventNo++;
		}
	}

}


// TvO[gݒ
void CMySynth::setSampleRate(float sampleRate){
	AudioEffectX::setSampleRate(sampleRate);

	m_pSynth->setFs(sampleRate);
}


// zXg̃VZp^ݒ
void CMySynth::setParameter(VstInt32 index, float value){
	m_pSynth->setSoundParam(index,value);
}

// zXg̃VZp^v
float CMySynth::getParameter(VstInt32 index){
	if(index >= 0 && index < SOUND_PARAM_NUM) return m_pSynth->m_pi[curProgram].soundParam[index];
	return 0.f;
}

// p^Ԃ
void CMySynth::getParameterName(VstInt32 index, char* text){
	char work[256];
	m_pSynth->getSoundParamName(index,work);
	work[kVstMaxParamStrLen]='\0';
	strcpy(text,work);
}

// p^lɑΉeLXgԂ
void CMySynth::getParameterDisplay(VstInt32 index, char* text){
	char work[256];
	m_pSynth->getSoundParamValText(index,work);
	work[kVstMaxParamStrLen]='\0';
	strcpy(text,work);
}

// vOԂ
bool CMySynth::getProgramNameIndexed(VstInt32 category, VstInt32 index, char* text){
	if(index < 0 || index >= PROGRAM_NUM) return false;

	vst_strncpy(text, &m_pSynth->m_pi[index].programName[0], kVstMaxProgNameLen);
	return true;
}

// Jg̃vOԂ
void CMySynth::getProgramName(char* name){
	vst_strncpy(name, &m_pSynth->m_pi[curProgram].programName[0], kVstMaxProgNameLen);
	return;
}

// Jg̃vO̕ύXv
void CMySynth::setProgramName(char* name){
	vst_strncpy(&m_pSynth->m_pi[curProgram].programName[0], name, kVstMaxProgNameLen);
	return;
}

// vO(pb`)̕ύXv
void CMySynth::setProgram(VstInt32 program){
	if(program < 0 || program >= PROGRAM_NUM) return;

	curProgram = program;
	m_pSynth->setProgramNo(program);
}

// pb`Ԃ
VstInt32 CMySynth::getChunk(void** data, bool isPreset){
	if(isPreset)	*data = (void*)&m_pSynth->m_pi[curProgram];
	else			*data = (void*)&m_pSynth->m_pi[0];
	if(isPreset)	return sizeof(PATCHINFO);
	else			return sizeof(PATCHINFO)*PROGRAM_NUM;
}

// pb`󂯎ēɐݒ肷
VstInt32 CMySynth::setChunk (void* data, VstInt32 byteSize, bool isPreset){
//edPrintf("setChunk() byteSize=%d, isPreset=%d SIZEOF(PATCHINFO)=%d\n",byteSize,isPreset,sizeof(PATCHINFO));
	if(isPreset){
		if(byteSize != sizeof(PATCHINFO)) return 0;
		m_pSynth->m_pi[curProgram] = *(PATCHINFO*)data;
	}else{
		if(byteSize != sizeof(PATCHINFO)*PROGRAM_NUM) return 0;
		for(int i=0;i<PROGRAM_NUM;i++)m_pSynth->m_pi[i] = ((PATCHINFO*)data)[i];
	}
	return 1;
}

