#pragma once
// synthBase.h
// VZ{̂ɕKvƂȂAMIDI߁A{CXRg[ȂǁAʓ|Ȏ
// ĂNXB


/////////////////////////////////////////////////////////////////////////
// M̃x[XNX
// TvOg̕ێAMoI/F`
class CSignalProcessor{
public:
	CSignalProcessor(){m_fs = 44100.f;};

	// TvOg֘A
	void setFs(float fs){m_fs=fs;changedSamplingFreq();};	// TvOgݒ
	virtual void changedSamplingFreq(void){};				// ̕ύXʒm

	// Mimj
	virtual void processSignal(int size, SIGREAL* pSig, BOOL* pProcessed){};

	// MiXeIj
	virtual void processSignalLR(int size, SIG_LR* pSig, BOOL* pProcessed){
		// ftHg(māAXeIf[^Ɋg)̒`
		// ܂ms
		processSignal(size,(SIGREAL*)pSig,pProcessed);
		if(*pProcessed){
			// mf[^XeIf[^֊g
			// d,sSIGREAL*łȂAint*gĂ̂FPU݂Ȃ߁B
			// fm[}FPUփ[hƃguɂȂB܂AFPUoRł͎኱xȂ\B
			int* s = (int*)pSig;
			int* d = s+(size-1)*2;
			for(int i=size-1;i>=0;i--,d-=2) *d=*(d+1)=s[i];
		}
	}

protected:
	float m_fs;		// TvOg
};


/////////////////////////////////////////////////////////////////////
// MIDI͉߃NX
class CMIDIInDev{
public:

	CMIDIInDev(void){
		m_programBankNo=m_NRPNNo=m_RPNNo=m_paramData=0;
	};

	virtual ~CMIDIInDev(){};

	// MIDIMʒm
	// `l{CXbZ[W
	virtual void receiveNoteOff(int nn,int v){};
	virtual void receiveNoteOn(int nn,int v){};
	virtual void receivePolyKeyPressure(int nn,int v){};
	// `l{CXbZ[W(Rg[`FW)
	virtual BOOL processMIDICCOriginal(BYTE st,BYTE dt1,BYTE dt2){return FALSE;};
	virtual void receiveModulationWheel(int v){};
	virtual void receiveVolume(int v){};
	virtual void receiveDumperPedal(BOOL b){};
	virtual void receiveNRPNData(int paramNo,int data,BOOL bHIByte){};
	virtual void receiveRPNData(int paramNo,int data,BOOL bHIByte){};
	// `l[hbZ[W
	virtual void receiveAllSoundOff(void){receiveAllNoteOff();};
	virtual void receiveResetAllController(void){
		receiveModulationWheel(0);
		receivePitchBend(0);
	};
	virtual void receiveAllNoteOff(void){
		receiveDumperPedal(FALSE);
		for(int i=0;i<128;i++)receiveNoteOff(i,0);
	};
	virtual void receiveProgramChange(int progNo,int bankNo){};
	virtual void receiveChannelPressure(int v){};
	virtual void receivePitchBend(int v){};

	// MIDIV[gbZ[WM
	void processMIDIShortData(BYTE st,BYTE dt1,BYTE dt2){
		int const nKind = st & 0xF0;
		int ch = st & 0x0F;
		switch(nKind){
		case 0x80:		// m[gIt
_NOTEOFF:
			if (dt1 < 0 || dt1 > 127) break;
			receiveNoteOff(dt1,dt2);
			break;

		case 0x90:		// m[gI
			if (dt2==0) goto _NOTEOFF;
			if (dt1 < 0 || dt1 > 127) break;
			receiveNoteOn(dt1,dt2);
			break;

		case 0xA0:		// |tHjbNL[vbV[
			receivePolyKeyPressure(dt1,dt2);
			break;

		case 0xB0:
			if(dt1<120){	// Rg[`FW
//edPrintf("Rg[`FWdt1,dt2=%02d,%02d\n",dt1,dt2);
				// ƎCCATC
				BOOL rtn = processMIDICCOriginal(st,dt1,dt2);
				if(rtn==TRUE) break;

				// ftHgCC
				switch(dt1){
				case 0x00:		// vOoNIiʁj
					m_programBankNo = MAKEWORD(LOBYTE(m_programBankNo),dt2);
					break;

				case 0x01:		// W[VzC[
					receiveModulationWheel(dt2);
					break;

				case 0x06:		// f[^Gg[iʁj
					setDataEntryHI(dt2);
					break;

				case 0x07:		// {[
					receiveVolume(dt2);
					break;

				case 0x20:		// vOoNIiʁj
					m_programBankNo = MAKEWORD(dt2,HIBYTE(m_programBankNo));
					break;

				case 0x26:		// f[^Gg[iʁj
					setDataEntryLO(dt2);
					break;

				case 0x40:		// _p[y_
					receiveDumperPedal(dt2 >= 64);
					break;

				case 0x62:		// mqomp^I()
					m_NRPNNo = MAKEWORD(LOBYTE(m_NRPNNo),dt2);
					m_RPNNo = -1;
					break;

				case 0x63:		// mqomp^I()
					m_NRPNNo = MAKEWORD(LOBYTE(m_NRPNNo),dt2);
					break;

				case 0x64:		// qomp^I()
					m_RPNNo = MAKEWORD(dt2,HIBYTE(m_RPNNo));
					m_NRPNNo = -1;
					break;

				case 0x65:		// qomp^I()
					m_RPNNo = MAKEWORD(dt2,HIBYTE(m_RPNNo));
					break;
				}

			}else{		// `l[hbZ[W
				switch(dt1){
				case 0x78:		// I[TEhIt
					receiveAllSoundOff();
					break;

				case 0x79:		// ZbgI[Rg[
					receiveResetAllController();
					break;

				case 0x7B:		// I[m[gIt
					receiveAllNoteOff();
					break;
				}
			}
			break;

		case 0xC0:		// vO`FW
			receiveProgramChange(dt1,m_programBankNo);
			break;

		case 0xD0:		// `lvbV[
			receiveChannelPressure(dt1);
			break;

		case 0xE0:		// sb`xh
//edPrintf("dt1,dt2=%02d,%02d\n",dt1,dt2);
			receivePitchBend(dt2*128+dt1-8192);
			break;

		case 0xF0:		// VXebZ[W
//edPrintf("VXebZ[W st=%02x,dt1,dt2=%02x,%02x\n",st,dt1,dt2);
			break;
		}

	};

private:
	int m_programBankNo;
	int m_NRPNNo;
	int m_RPNNo;
	int m_paramData;

	void setDataEntryHI(BYTE dt2){
		m_paramData = MAKEWORD(LOBYTE(m_paramData),dt2);
		if(m_NRPNNo != -1)	receiveNRPNData(m_NRPNNo,m_paramData,TRUE);
		else				receiveRPNData(m_RPNNo,  m_paramData,TRUE);
	};

	void setDataEntryLO(BYTE dt2){
		m_paramData = MAKEWORD(dt2,HIBYTE(m_paramData));
		if(m_NRPNNo != -1)	receiveNRPNData(m_NRPNNo,m_paramData,FALSE);
		else				receiveRPNData(m_RPNNo,  m_paramData,FALSE);
	};

};


///////////////////////
// ՏǗNX
// {CX̃gK[/[XRg[邽߂ɁAꂽՂ̏LAǗNX
class CKeyboardInfo{
public:
	CKeyboardInfo(){
		m_onKeyNum=0;
		m_statusChanged=m_bDumper=FALSE;
		for(int i=0;i<128;i++) m_keyTable[i]=m_dumperTable[i]=0;
	};
	virtual ~CKeyboardInfo(){};
	// L[Ō
	void onKey(int nn,int v){
		if(m_keyTable[nn] != 0) offKeyImpl(nn);
		m_keyTable[nn] = v;
		m_dumperTable[nn]=FALSE;
		m_onKeyNNList[m_onKeyNum]=nn+256;	// +256͐VKtO
		m_onKeyNum++;
		m_statusChanged=TRUE;
	};
	// L[
	void offKey(int nn){
		if(m_bDumper) m_dumperTable[nn]=TRUE;
		else offKeyImpl(nn);
	};
	// _p[y_̓/
	void setDumper(BOOL v){
		m_bDumper = v;
		if(!m_bDumper){
			for(int i=0;i<128;i++){
				if(m_dumperTable[i]){
					m_dumperTable[i]=FALSE;
					offKeyImpl(i);
				}
			}
		}
	};
	// nԖڂɐVL[̃m[gNO擾BȂ΁A-1ԂB
	int getOnKeyNN(int n){
		if(n >= m_onKeyNum) return -1;
		return m_onKeyNNList[m_onKeyNum-1-n];
	};
	// nԖڂɐVVKL[̃m[gNO擾BȂ΁A-1ԂB
	int getNewOnKeyNN(int n){
		if(n >= m_onKeyNum) return -1;
		int noteNo = m_onKeyNNList[m_onKeyNum-1-n];
		if(noteNo < 256) return -1;		// VKł͂Ȃ
		return noteNo-256;
	};
	// ՏԕύXtOZbg
	void resetStatusChange(void){
		m_statusChanged=FALSE;
		// VKtOׂėƂ
		for(int i=0;i<m_onKeyNum;i++) if(m_onKeyNNList[i] >= 256) m_onKeyNNList[i] -= 256;
	};
	// L[IĂL[̐Ԃ
	int getOnKeyNum(void){return m_onKeyNum;};
	// ŌɃR[resetStatusChange()献ՏԂύXĂ邩HԂ
	BOOL isStatusChanged(void){return m_statusChanged;};
	// ̃xVeBlԂ
	int getVelocity(int nn){return m_keyTable[nn];};	

private:
	int m_onKeyNum;				// ̃L[
	int m_keyTable[128];		// L[ƃxVeBƂ̑Ή\
	int m_onKeyNNList[128];		// ꂽL[̏Ԃێ郊Xg
	BOOL m_bDumper;				// _p[y_tO
	BOOL m_dumperTable[128];	// _p[ItŁA[XׂՏ
	BOOL m_statusChanged;		// L[̉ԂύXꂽ̃tO

	// L[ItɎgpTu[`
	void offKeyImpl(int nn){
		m_keyTable[nn] = 0;
		m_statusChanged=TRUE;
		// IL[XgAL[ItՏ菜
		for(int i=0;i<m_onKeyNum;i++){
			int onNN = m_onKeyNNList[i];
			if(nn == ((onNN >= 256) ? onNN-256 : onNN)){
				for(;i<m_onKeyNum-1;i++) m_onKeyNNList[i]=m_onKeyNNList[i+1];
				m_onKeyNum--;
				return;
			}
		}
	};
};


///////////////////////
// {CX(Interface)
class IVoice : public CSignalProcessor{
public:
	IVoice(){m_no=0;m_pan=0.5f;};
	void setNo(int no){m_no=no;};				// {CXʂ邽߂̃{CXԍ(A)ݒ
	int getNo(void){return m_no;};				// {CXԍԂ
	virtual void setDetune(float det){};		// f`[lݒAPʂ̓Zg
	virtual void setPan(float pan){m_pan=pan;};	// plݒ
	virtual float getPan(void){return m_pan;};	// plԂ
	virtual void setNoteInfo(int nn,int velo){};// Um[gNo̐ݒBL[IɃR[B
	// j]{CẌׂ̏ݒB{CXԂňʑ𐧌䂷鎞̈חpBL[IɃR[B
	virtual void setUnisonInfo(IVoice* pMasterVoice,int unisonNum, int unisonNo){};
	virtual void trigger(void){};				// L[gK[ʒm
	virtual void release(int velo){};			// L[[Xʒm
	virtual int  getNoteNo(void){return 0;};	// Um[gNoԂ
	virtual BOOL isKeyOn(void){return FALSE;};	// L[IԂ
	// {CXrW[()ǂԂ
	// isKeyOn()ȃL[ON/OFFtOȂ̂ɑ΂AisBusy()͌ݔĂ邩ǂԂB
	// L[ItԂisKeyOn()FALSEԂ悤ȏ󋵂łA[XĂԂȂAisBusy()TRUEԂB
	virtual BOOL isBusy(void){return FALSE;};

protected:
	int m_no;		// {CXԍ
	float m_pan;	// {CXpl(0=left ... 0.5=center ... 1=right)
};



///////////////////////////////////////////////////
// {CXRg[[
// {CXǗɂāAL[[hɉāAgK[/[XsB
#define KM_POLY			0	// |
#define KM_MONO			1	// m
#define KM_MONO2		2	// K[g

class CVoiceCtl : public CSignalProcessor {
public:
	CVoiceCtl();

	void setKeyboardInfo(CKeyboardInfo* p);	// L[{[hǗNX̐ݒ
	void setVoiceNum(int n);				// Ǘ{CX̐ݒ
	void setVoice(int no,IVoice* pV);		// Ǘe{CX̐ݒ
	void setVoiceMode(int mode);			// L[[h̐ݒ
	void setUnisonVoiceNum(int n);			// j]{CX̐ݒ
	void controlVoiceTrigger(void);			// gK[/[X𐧌䂷
	// Mi{CX̐MsAXeIMIXj
	void processSignalLR(int size, SIG_LR* pSig, BOOL* pProcessed);

private:
	int m_keyMode;				// L[[h
	CKeyboardInfo* m_pKbdInfo;	// L[{[hǗNX
	int m_voiceNum;				// o^ꂽ{CX̐
	int m_polyNum;				// |[h̍ő{CX
	int m_unisonNum;			// j]{CX

	IVoice* m_pVoices[128];			// Ǘ{CX
	int m_curVoiceNo;				// Jg{CXԍ
	std::list<IVoice*> m_onVoices;	// L[Ĩ{CXXg
	int m_monoCurrentVelocity;		// m[hɎg[NpxVeVeBl
	IVoice* getNextOffVoice(void);	// 󂫃{CX̃T[`
	void controlVoicePoly(void);	// |[hł̃gK[/[X
	void controlVoiceMono(void);	// m[hł̃gK[/[X
};


